#ifndef DEQUEUE_H_
#define DEQUEUE_H_

#include <stddef.h>

struct dequeue;

struct dequeue * dequeue_new(size_t const size);
void dequeue_delete(struct dequeue * deq);
void * dequeue_push_top(struct dequeue * deq, void * elem);
void * dequeue_pop_top(struct dequeue * deq);
void * dequeue_push_bottom(struct dequeue * deq, void * elem);
void * dequeue_pop_bottom(struct dequeue * deq);
size_t dequeue_size(struct dequeue * deq);

#endif
